/*
      
   "- ".

  Copyright (C) 1998 by Alien AKA Dimik (dimik@infopro.spb.su).
*/

#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <dos.h>

#define PORT_BASE 0x378     /*     */
#define SIZE 16             /*    */

void reading(unsigned char *lpszBuffer)
{
  unsigned char value;
  int i, j;

  outportb(PORT_BASE, 0xF9);
  /* delay(10); */
  outportb(PORT_BASE, 0xFB);
  /* delay(10); */
  outportb(PORT_BASE, 0xF9);
  /* delay(10); */
  outportb(PORT_BASE, 0xF8);
  /* delay(10); */
  for(i = 0; i < SIZE; i++) {
     value = 0;
     for(j = 0; j < 8; j++) {
        value = (value << 1) + ((~inportb(PORT_BASE+1) & 0x80) >> 7);
        outportb(PORT_BASE, 0xFA);
        /* delay(1); */
        outportb(PORT_BASE, 0xF8);
        /* delay(1); */
     }
     *(lpszBuffer + i) = value;
  }
}

/*
     .
*/
unsigned long Units(const unsigned char *lpszBuffer)
{
  unsigned long ulUnits = 0;
  unsigned char ch;
  int i, nBitCounter;

  for(i = 8; i < 13; i++) {
    for(nBitCounter = 0, ch = *(lpszBuffer + i);
       ch & 1; ch >>=1, nBitCounter++);
    ulUnits = ulUnits * 8 + nBitCounter;
  }
  return ulUnits;
}

/*
    .
*/
unsigned long Serial(unsigned char *lpszBuffer)
{
  unsigned char szReverse[4], chr, ch;
  int i, j;

  for(i = 0; i < 4; i++) {
    chr = 0; ch = *(lpszBuffer + 4 + i);
    for(j = 0; j < 8; j++) { chr = (chr << 1) + (ch & 1); ch >>= 1; }
    szReverse[i] = chr;
  }
  return *(unsigned long *)szReverse;
}

void main(void)
{
  unsigned char szBuffer[2][SIZE];
  int success = 0, ind, i, j, k;

  printf("Waiting for successful reading payphone card.\n");
  printf("Press any key for interrupt...\n");

  /*     ,  
           .
           
       .
  */
  ind = 0;
  while(!kbhit() && !success) {
    reading(szBuffer[ind]);
    for(k = 0; k < SIZE; k++) if(szBuffer[ind][k] != 0xFF) {
      for(k = 0; k < SIZE; k++)
        if(szBuffer[ind][k] != szBuffer[1-ind][k]) break;
      if(k == SIZE) success = 1;
      break;
    }
    ind = 1 - ind;
  }

  if(!success) {
    printf("Interrupted by user.\n");
    exit(-1);
  }
  printf("-- Data from card --\n");
  for(i = 0; i < (SIZE / 8); i++) {
    for(j = 0; j < 8; j++) printf("%02X ",
          (unsigned)szBuffer[ind][i*8+j]);
    printf("\n");
  }

  printf("-- Data decoded --\n");
  printf("Serial number: %010ld\n", Serial(szBuffer[ind]));
  printf("Units left: %ld\n", Units(szBuffer[ind]));
}
